Template Numerical Library: TNL::Algorithms::Segments::ChunkedEllpackView< Device, Index, Organization > Class Template Reference

Template Numerical Library version\ main:be7e16d88

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
TNL::Algorithms::Segments::ChunkedEllpackView< Device, Index, Organization > Class Template Reference
Inheritance diagram for TNL::Algorithms::Segments::ChunkedEllpackView< Device, Index, Organization >:
[legend]
Collaboration diagram for TNL::Algorithms::Segments::ChunkedEllpackView< Device, Index, Organization >:
[legend]

## Public Types
using | ConstViewType = ChunkedEllpackView< Device, std::add_const_t< Index >, Organization >
template<typename Device_, typename Index_>
using | ViewTemplate = ChunkedEllpackView< Device_, Index_, Organization >
using | ViewType = ChunkedEllpackView
Public Types inherited from TNL::Algorithms::Segments::ChunkedEllpackBase< Device, Index, Algorithms::Segments::DefaultElementsOrganization< Device >::getOrganization() >
using | ConstOffsetsView
using | ConstSliceInfoContainerView
using | DeviceType
using | IndexType
using | OffsetsView
using | SegmentViewType
using | SliceInfoContainerView
using | SliceInfoType
using | ViewTemplate

## Public Member Functions
__cuda_callable__ | ChunkedEllpackView (ChunkedEllpackView &&) noexcept=default
__cuda_callable__ | ChunkedEllpackView (const ChunkedEllpackView &)=default
__cuda_callable__ | ChunkedEllpackView (Index size, Index storageSize, Index numberOfSlices, Index chunksInSlice, Index desiredChunkSize, typename Base::OffsetsView segmentToChunkMapping, typename Base::OffsetsView segmentToSliceMapping, typename Base::OffsetsView chunksToSegmentsMapping, typename Base::OffsetsView segmentPointers, typename Base::SliceInfoContainerView slices)
__cuda_callable__ void | bind (ChunkedEllpackView view)
__cuda_callable__ ConstViewType | getConstView () const
__cuda_callable__ ViewType | getView ()
void | load (File &file)
ChunkedEllpackView & | operator= (ChunkedEllpackView &&)=delete
ChunkedEllpackView & | operator= (const ChunkedEllpackView &)=delete
void | save (File &file) const
Public Member Functions inherited from TNL::Algorithms::Segments::ChunkedEllpackBase< Device, Index, Algorithms::Segments::DefaultElementsOrganization< Device >::getOrganization() >
void | forAllElements (Function &&function) const
void | forAllSegments (Function &&function) const
void | forElements (IndexType begin, IndexType end, Function &&function) const
void | forSegments (IndexType begin, IndexType end, Function &&function) const
__cuda_callable__ IndexType | getChunksInSlice () const
__cuda_callable__ OffsetsView | getChunksToSegmentsMappingView ()
__cuda_callable__ IndexType | getDesiredChunkSize () const
__cuda_callable__ IndexType | getGlobalIndex (IndexType segmentIdx, IndexType localIdx) const
__cuda_callable__ IndexType | getNumberOfSlices () const
__cuda_callable__ OffsetsView | getSegmentPointersView ()
__cuda_callable__ IndexType | getSegmentsCount () const
__cuda_callable__ IndexType | getSegmentSize (IndexType segmentIdx) const
__cuda_callable__ OffsetsView | getSegmentToChunkMappingView ()
__cuda_callable__ OffsetsView | getSegmentToSliceMappingView ()
__cuda_callable__ SegmentViewType | getSegmentView (IndexType segmentIdx) const
__cuda_callable__ IndexType | getSize () const
__cuda_callable__ SliceInfoContainerView | getSlicesView ()
__cuda_callable__ IndexType | getStorageSize () const
ChunkedEllpackBase & | operator= (const ChunkedEllpackBase &)=delete
void | printStructure (std::ostream &str) const

## Additional Inherited Members
Static Public Member Functions inherited from TNL::Algorithms::Segments::ChunkedEllpackBase< Device, Index, Algorithms::Segments::DefaultElementsOrganization< Device >::getOrganization() >
static constexpr ElementsOrganization | getOrganization ()
static std::string | getSegmentsType ()
static std::string | getSerializationType ()
static constexpr bool | havePadding ()
Protected Member Functions inherited from TNL::Algorithms::Segments::ChunkedEllpackBase< Device, Index, Algorithms::Segments::DefaultElementsOrganization< Device >::getOrganization() >
__cuda_callable__ void | bind (IndexType size, IndexType storageSize, IndexType numberOfSlices, IndexType chunksInSlice, IndexType desiredChunkSize, OffsetsView segmentToChunkMapping, OffsetsView segmentToSliceMapping, OffsetsView chunksToSegmentsMapping, OffsetsView segmentPointers, SliceInfoContainerView slices)
| Re-initializes the internal attributes of the base class.
Protected Attributes inherited from TNL::Algorithms::Segments::ChunkedEllpackBase< Device, Index, Algorithms::Segments::DefaultElementsOrganization< Device >::getOrganization() >
IndexType | chunksInSlice
OffsetsView | chunksToSegmentsMapping
IndexType | desiredChunkSize
IndexType | numberOfSlices
OffsetsView | segmentPointers
| Keeps index of the first segment index.
OffsetsView | segmentToChunkMapping
| For each segment, this keeps index of the first chunk within a slice.
OffsetsView | segmentToSliceMapping
| For each segment, this keeps index of the slice which contains the segment.
IndexType | size
SliceInfoContainerView | slices
IndexType | storageSize

The documentation for this class was generated from the following file:

- src/TNL/Algorithms/Segments/ChunkedEllpackView.h